// FopDemoDlg.cpp : implementation file
//

#include "stdafx.h"
#include "FopDemo.h"
#include "FopDemoDlg.h"
#include "FileOperations.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

#pragma warning(disable : 4800)

static char strHelp[] = "This code allows to copy, move or delete files or directories (with subdirectories and files) without using SHFileOperation function. If 'AskIfReadonly' flag is set then during delete operation warning message will be shown. During move operation this flag ignorable. If 'OverwriteMode' flag is set then if you copy file to the existing file it will overwrite it. Otherwise file will be copied as new file with name 'Copy of ORIGINAL_FILE_NAME'. If this file already exist it will be copied as 'Copy (2) of ORIGINAL_FILE_NAME' and so on.";

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CFopDemoDlg dialog

CFopDemoDlg::CFopDemoDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CFopDemoDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CFopDemoDlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CFopDemoDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CFopDemoDlg)
		// NOTE: the ClassWizard will add DDX and DDV calls here
		DDX_Text(pDX, IDC_EDIT1, m_sSource);
		DDX_Text(pDX, IDC_EDIT2, m_sDest);
		DDX_Check(pDX, IDC_CHECK1, m_iAskIfReadonly);
		DDX_Check(pDX, IDC_CHECK2, m_iOverwriteMode);
		DDX_Control(pDX, IDC_EDIT4, m_Edit);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CFopDemoDlg, CDialog)
	//{{AFX_MSG_MAP(CFopDemoDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_BUTTON1, OnCopy)
	ON_BN_CLICKED(IDC_BUTTON2, OnMove)
	ON_BN_CLICKED(IDC_BUTTON3, OnDelete)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CFopDemoDlg message handlers

BOOL CFopDemoDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here
	m_iAskIfReadonly = 1;
	UpdateData(FALSE);
	m_Edit.SetWindowText(strHelp);
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CFopDemoDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CFopDemoDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CFopDemoDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CFopDemoDlg::OnCopy() 
{
	BeginWaitCursor();
	UpdateData();
	CFileOperation fo;
	fo.SetAskIfReadOnly(m_iAskIfReadonly);
	fo.SetOverwriteMode(m_iOverwriteMode);
	if (!fo.Copy(m_sSource, m_sDest)) fo.ShowError();
	EndWaitCursor();
}

void CFopDemoDlg::OnMove() 
{
	BeginWaitCursor();
	UpdateData();
	CFileOperation fo;
	fo.SetAskIfReadOnly(m_iAskIfReadonly);
	fo.SetOverwriteMode(m_iOverwriteMode);
	if (!fo.Replace(m_sSource, m_sDest)) fo.ShowError();	
	EndWaitCursor();
}

void CFopDemoDlg::OnDelete() 
{
	BeginWaitCursor();
	UpdateData();
	CFileOperation fo;
	fo.SetAskIfReadOnly(m_iAskIfReadonly);
	fo.SetOverwriteMode(m_iOverwriteMode);
	if (!fo.Delete(m_sSource)) fo.ShowError();	
	EndWaitCursor();
}
